#ifndef __aa27fd1a75eb4409bc6f32033fb25e4a__
#define __aa27fd1a75eb4409bc6f32033fb25e4a__

#ifndef __windows_inc__
#include "windows.inc"
#endif
// todo: change scan algorithm in FindFigure


// file database structure
struct OCR_NODE,1
{
	int   character;
	int64 bits;
}

const DEFAULT_ACCESS = GENERIC_WRITE | GENERIC_READ;

class OCR
{
	declare  OCR();
	declare _OCR();

	declare OpenDatabase(TCHAR *path,opt DWORD dwAccess=DEFAULT_ACCESS),BOOL;
	declare Cleanup();

//	declare LoadImage(wstring path),BOOL; // todo!
	declare SetImage(HBITMAP hbm),BOOL; // auto TransformMonochrome();

	// returns text of line pointed by the prcScan->top member
	// and modifies the .top member to currentLine->bottom+1
	// does not search above .right and .bottom
	declare GetLineTextA(string *text, int cch, RECT *prcScan, /*out*/RECT *prcLine),int;

	// returns the whole text
	declare GetTextA(string *text, int cch, RECT *prcScan),int;

	declare GetLineTextFromRectA(string *text, int cch, RECT *prcScan,opt POINT *ptStart=NULL),int;

//private
	declare TransformMonochrome();

	// find next letter in the bitmap
//todo: check prcScan and ptStart
	declare FindFigure(RECT *prcScan, RECT *prcFigure,opt POINT *ptStart=NULL),BOOL; // search for first letter
	// prcScan   - [in]  rectangle where to search
	// prcFigure - [out] letter rectangle
	// ptStart   - [in]  start position to seatch, [out] offset to next character

	declare FindNextLine(RECT *pSearchRect,RECT *pLineRect),BOOL;
	declare ParseImageChunk(RECT *prc),int64; // convert letter to 64-bit bitmap
	declare GetCharacter(int64 bits, RECT *prc),int; // convert 64-bit bitmap to ascii

	declare FillFigure(); // red floodfill, letter size is calculated here
	declare ExtractImageChunk(RECT *prc),HBITMAP;

	declare virtual OnUnknownCharacter(HBITMAP hbm, int *ppCharacter),BOOL;
	declare virtual OnCharacterAdded(int character);

	// browsing
	declare GetFirstNode(OCR_NODE *pNode),BOOL;
	declare GetNextNode(OCR_NODE *pNode),BOOL;

	declare GetPixel(int x,int y),COLORREF;
	declare SetPixel(int x,int y,COLORREF color);
	declare ValidareScanRect(RECT *prcScan);
//	declare DeleteNode(int index),BOOL;
//	declare UpdateNode(int index, ),BOOL;

	HANDLE  m_hFile;
//	HDC     m_hdcImage;
	HBITMAP m_hbmImage;
	HBITMAP m_hbmOriginalImage;
//	HBITMAP m_hbmOldImage;
	int     m_width, m_heigth;
	int     m_x, m_y; // FindFigure and FillFigure
	RECT   *m_prc;    // FindFigure and FillFigure
	DWORD   m_ReadNodePos; // GetFirstNode, GetNextNode
	COLORREF *m_pBits;
}

#endif
